import * as _jitl_quickjs_ffi_types from '@jitl/quickjs-ffi-types';
import { EmscriptenModuleLoader, QuickJSEmscriptenModule } from '@jitl/quickjs-ffi-types';
import { QuickJSFFI } from './ffi.mjs';

// Generated from ../../templates/emscripten-module.SYNC.d.ts

/**
 *  Emscripten module built from the unmodified [`quickjs/quickjs.h`](../quickjs/quickjs.h)
 *  and our FFI support functions [c/interface.c](../c/interface.c).
 *
 * Note that emscripten modules returned by a `MODULARIZE=1` emscripten build
 * (like this one) load asynchronously.
 */
declare const ModuleLoader: EmscriptenModuleLoader<QuickJSEmscriptenModule>

declare namespace ___dist_emscripten_module_browser_js {
  export { ModuleLoader as default };
}

/**
 * This export is a variant of the quickjs WASM library:
 * ### [@jitl/quickjs-wasmfile-release-sync](https://github.com/justjake/quickjs-emscripten/blob/main/doc/packages/@jitl/quickjs-wasmfile-release-sync/README.md)
 *
 * Variant with separate .WASM file. Supports browser, NodeJS ESM, and NodeJS CJS.
 *
 * | Variable            |    Setting                     |    Description    |
 * | --                  | --                             | --                |
 * | releaseMode         | release         | Optimized for performance; use when building/deploying your application. |
 * | syncMode            | sync            | The default, normal build. Note that both variants support regular async functions. |
 * | emscriptenInclusion | wasm | Has a separate .wasm file. May offer better caching in your browser, and reduces the size of your JS bundle. If you have issues, try a 'singlefile' variant. |
 * | exports             | require import browser                  | Has these package.json export conditions |
 *
 */
declare const variant: {
    readonly type: "sync";
    readonly importFFI: () => Promise<typeof QuickJSFFI | (new (module: _jitl_quickjs_ffi_types.QuickJSEmscriptenModule) => _jitl_quickjs_ffi_types.QuickJSFFI)>;
    readonly importModuleLoader: () => Promise<typeof ___dist_emscripten_module_browser_js | _jitl_quickjs_ffi_types.EmscriptenModuleLoader<_jitl_quickjs_ffi_types.QuickJSEmscriptenModule> | {
        default: _jitl_quickjs_ffi_types.EmscriptenModuleLoader<_jitl_quickjs_ffi_types.QuickJSEmscriptenModule>;
    } | {
        default: {
            default: _jitl_quickjs_ffi_types.EmscriptenModuleLoader<_jitl_quickjs_ffi_types.QuickJSEmscriptenModule>;
        };
    }>;
};

export { variant as default };
